function initMeadow()
  for i=1,1200 do
    meadow[i]=0 -- fill with grass
    meadowstate[i]=0 -- everything starts as dead (alpha 0)
  end
  i=0
  while i<401 do -- fill 1/3 of the meadow with dead flowers
    local cell=math.random(1200)
    if meadow[cell]==0 then meadow[cell]=1 i=i+1 end
  end
end

function love.load()
  meadow={} -- for each cell: 0=grass, 1=dead/reviving, 2=alive
  meadowstate={} -- if non-zero, it's reviving (this is also our variable for the alpha channel)
  initMeadow()
  grass=love.graphics.newImage("grass.png")
  deadflower=love.graphics.newImage("dead.png")
  liveflower=love.graphics.newImage("alive.png")
  beeu=love.graphics.newImage("beeu.png")
  beed=love.graphics.newImage("beed.png")
  beel=love.graphics.newImage("beel.png")
  beer=love.graphics.newImage("beer.png")
  player={}
  player.x=320
  player.y=240
  player.img=beeu
  player.dir=nil
end

function love.keypressed(k)
  if k=="escape" then love.event.push("quit") end
  if k=="r" then
    initMeadow()
    player.x=320
    player.y=240
    player.img=beeu
    player.dir=nil
  end
  if k=="up" or k=="w" then player.img=beeu player.dir="u" end
  if k=="down" or k=="s" then player.img=beed  player.dir="d" end
  if k=="left" or k=="a" then player.img=beel  player.dir="l" end
  if k=="right" or k=="d" then player.img=beer  player.dir="r" end
end

 function love.keyreleased(k) player.dir=nil end

function love.draw()
  local x,y=0,0
  for i=1,1200 do
    if x%640==0 and x>0 then x=0 y=y+16 end
    love.graphics.setColor(255,255,255,255)
    if meadow[i]==0 then love.graphics.draw(grass,x,y) end
    if meadow[i]==1 then
      love.graphics.draw(deadflower,x,y)
      if meadowstate[i]>0 then
        love.graphics.setColor(255,255,255,meadowstate[i])
        love.graphics.draw(liveflower,x,y)
      end
    end
    love.graphics.setColor(255,255,255,255)
    if meadow[i]==2 then love.graphics.draw(liveflower,x,y) end
    x=x+16
  end
  love.graphics.setColor(255,255,255,255)
  love.graphics.draw(player.img,player.x,player.y)
end

function love.update(dt)
  for i=1,1200 do
    if meadowstate[i]>0 then meadowstate[i]=meadowstate[i]+(200*dt) end
    if meadowstate[i]>=255 then meadow[i]=2 meadowstate[i]=0 end
  end
  if player.dir~=nil then
    if player.dir=="u" then player.y=math.floor(player.y-(200*dt)) end
    if player.dir=="d" then player.y=math.floor(player.y+(200*dt)) end
    if player.dir=="l" then player.x=math.floor(player.x-(200*dt)) end
    if player.dir=="r" then player.x=math.floor(player.x+(200*dt)) end
    if player.x<0 then player.x=0 end
    if player.x>624 then player.x=624 end
    if player.y<0 then player.y=0 end
    if player.y>464 then player.y=464 end
    local cell=(math.floor((player.y+8)/16)*40)+(math.floor((player.x+8)/16))+1 -- ugh. not perfect, but gets the job more or less done
    if meadow[cell]==1 and meadowstate[cell]==0 then meadowstate[cell]=1 end
  end
end